<?php

/**
  * Translations tab for admin panel, AdminTranslationsFields.php
  * @category admin
  *
  * @author PrestaShop <support@prestashop.com>
  * @copyright PrestaShop
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.8
  *
  */

class AdminTranslationsFields extends AdminTab
{
	public function postProcess()
	{
		global $currentIndex;
	
		if (Tools::getValue('submitTranslations'))
		{
		 	/* Create a new language file */
			if ($fd = fopen(_PS_CLASS_DIR_.'lang/'.strtolower(Tools::getValue('lang')).'.php', 'w'))
			{
				unset($_POST['submitTranslations']);
				unset($_POST['lang']);
				$toInsert = array();
				foreach($_POST as $key => $value)
					if (!empty($value))
						$toInsert[$key] = pSQL($value);
				fwrite($fd, "<?php\n\nglobal \$_FIELDS;\n\$_FIELDS = array();\n");
				foreach($toInsert as $key => $value)
					fwrite($fd, '$_FIELDS[\''.$key.'\'] = \''.$value.'\';'."\n");
				fwrite($fd, "\n?>");
				Tools::redirectAdmin($currentIndex.'&conf=4');
			}
			else
				die('Cannot write language file');
		}
		elseif (isset($_GET['lang']))
			$this->displayForm();
	}
	
	public function display()
	{
		global $currentIndex;
		
		if (!isset($_GET['lang']))
		{
			echo $this->l('Please select a language by clicking on the corresponding flag').'.<br /><br />';
			$languages = Language::getLanguages();
			if (sizeof($languages) == 1)
				Tools::redirectLink($currentIndex.'&lang='.$languages[0]['iso_code']);
			foreach ($languages as $language)
				echo '<a href="'.$currentIndex.'&lang='.$language['iso_code'].'" >
						<img src="'._THEME_LANG_DIR_.'/'.$language['id_lang'].'.jpg" alt="'.$language['iso_code'].'" title="'.$language['iso_code'].'" />
					</a> ';
		}
	}
	
	function displayForm()
	{
		global $currentIndex;
		
		$lang = Tools::getValue('lang');
		$_FIELDS = array();
		@include(_PS_CLASS_DIR_.'lang/'.strtolower($lang).'.php');
		$classArray = array();
		foreach (scandir(_PS_CLASS_DIR_) AS $classFile)
		{
			if (!preg_match('/\.php$/', $classFile))
				continue;
			include_once(_PS_CLASS_DIR_.$classFile);
			$className = substr($classFile, 0, -4);
			if (!class_exists($className))
				continue;
			if (!is_subclass_of($className, 'ObjectModel'))
				continue;
			$classArray[] = $className;			
		}
		
		
		echo '
		<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>
		<form method="post" action="'.$currentIndex.'&submitTranslations=1" class="form">
			<input type="hidden" name="lang" value="'.$lang.'" />';
		foreach ($classArray AS $className)
		{
			$rules = call_user_func(array($className, 'getValidationRules'), $className);
			echo '
			<fieldset class="width3"><legend>'.$className.'</legend>
				<table cellpadding="2">';
			if (isset($rules['validate']))
				foreach ($rules['validate'] AS $key => $value)
					echo '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.$className.'_'.md5($key).'" value="'.(array_key_exists($className.'_'.md5($key), $_FIELDS) ? $_FIELDS[$className.'_'.md5($key)] : '').'" style="width: 350px"></td></tr>';
			if (isset($rules['validateLang']))
				foreach ($rules['validateLang'] AS $key => $value)
					echo '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.$className.'_'.md5($key).'" value="'.(array_key_exists($className.'_'.md5($key), $_FIELDS) ? $_FIELDS[$className.'_'.md5($key)] : '').'" style="width: 350px"></td></tr>';
			echo '
				</table>
			</fieldset><br />';
		}
		echo '<br /><input type="submit" name="submitTranslations" value="'.$this->l('Update translations').'" class="button" /></form>';
	}
}

?>