<?php

/**
  * Translations tab for admin panel, AdminTranslationsFront.php
  * @category admin
  *
  * @author PrestaShop <support@prestashop.com>
  * @copyright PrestaShop
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.8
  *
  */

class AdminTranslationsFront extends AdminTab
{

	public function postProcess()
	{
		global $currentIndex;
	
		if (Tools::getValue('submitTranslations'))
		{
		 	/* Create a new language file */
			if ($fd = fopen(_PS_THEME_DIR_.'lang/'.strtolower($_POST['lang']).'.php', 'w'))
			{
				unset($_POST['submitTranslations']);
				unset($_POST['lang']);
				$toInsert = array();
				foreach($_POST as $key => $value)
					if (!empty($value))
						$toInsert[substr($key, -32)] = pSQL($value);
				fwrite($fd, "<?php\n\nglobal \$_LANG;\n\$_LANG = array();\n");
				foreach($toInsert as $key => $value)
					fwrite($fd, '$_LANG[\''.$key.'\'] = \''.$value.'\';'."\n");
				fwrite($fd, "\n?>");
				Tools::redirectAdmin($currentIndex.'&conf=4');
			}
			else
				die('Cannot write language file');
		}
		elseif (isset($_GET['lang']))
			$this->displayForm();
	}
	
	public function display()
	{
		global $currentIndex;
		
		if (!isset($_GET['lang']))
		{
			echo $this->l('Please select a language by clicking on the corresponding flag').'.<br /><br />';
			$languages = Language::getLanguages();
			if (sizeof($languages) == 1)
				Tools::redirectLink($currentIndex.'&lang='.$languages[0]['iso_code']);
			foreach ($languages as $language)
				echo '<a href="'.$currentIndex.'&lang='.$language['iso_code'].'" >
						<img src="'._THEME_LANG_DIR_.'/'.$language['id_lang'].'.jpg" alt="'.$language['iso_code'].'" title="'.$language['iso_code'].'" />
					</a> ';
		}
	}
	
	function displayForm()
	{
		global $currentIndex;
		
		$lang = Tools::getValue('lang');
		$_LANG = array();
		
		if (!file_exists(_PS_THEME_DIR_.'lang'))
			if (!mkdir(_PS_THEME_DIR_.'lang', 0700))
				die('Please create a "lang" directory in '._PS_THEME_DIR_);
		if (!file_exists(_PS_THEME_DIR_.'lang/'.strtolower($lang).'.php'))
			if (!file_put_contents(_PS_THEME_DIR_.'lang/'.strtolower($lang).'.php', "<?php\n\nglobal \$_LANG;\n\$_LANG = array();\n\n?>"))
				die('Please create a "'.strtolower($lang).'.php" file in '._PS_THEME_DIR_.'lang/');
		include(_PS_THEME_DIR_.'lang/'.strtolower($lang).'.php');
		$files = array();
		
		/* List templates to parse */
		$templates = scandir(_PS_THEME_DIR_);
		$count = 0;
		foreach ($templates AS $template)
			if (ereg('^(.*).tpl$', $template) AND file_exists($tpl = _PS_THEME_DIR_.$template))
			{
				$newLang = array();
				$fd = fopen($tpl, 'r');
				$content = fread($fd, filesize($tpl));
				
				/* Search language tags (eg {l s='to translate'}) */
				$regex = '/\{l s=\'(.+)\'( js=1)?\}/U';
				preg_match_all($regex, $content, $matches);
				
				/* Get string translation */
				foreach($matches[1] as $key)
					$newLang[$key] = (key_exists(md5($key), $_LANG)) ? $_LANG[md5($key)] : '';
				$files[$template] = $newLang;
				$count += sizeof($newLang);
			}
		
		echo '
		<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>
		'.$this->l('Expressions to translate').' : <b>'.$count.'</b>. '.$this->l('Click on the titles to open fieldsets').'.<br /><br />
		<form method="post" action="'.$currentIndex.'&submitTranslations=1" class="form">
			<input type="hidden" name="lang" value="'.$lang.'" />
			<input type="button" class="button" onclick="this.value = \''.$this->l('Please wait...').'\';';
		foreach	($files as $k => $newLang)
			if (sizeof($newLang))
				echo 'openCloseLayer(\''.$k.'\');';
		echo 'this.value = \''.$this->l('Open/Close all fieldsets').'\';" value="'.$this->l('Open/Close all fieldsets').'" /> <input type="submit" name="submitTranslations" value="'.$this->l('Update translations').'" class="button" /><br /><br />';
		foreach ($files as $k => $newLang)
			if (sizeof($newLang))
			{
				$countValues = array_count_values($newLang);
				$empty = isset($countValues['']) ? $countValues[''] : 0;
			 	echo '
				<fieldset class="width3"><legend style="cursor : pointer" onclick="openCloseLayer(\''.$k.'\')">'.$k.' - <font color="blue">'.sizeof($newLang).'</font> '.$this->l('expressions').' (<font color="red">'.$empty.'</font>)</legend>
					<div id="'.$k.'" style="display: '.($empty ? 'block' : 'none').';"> 
						<table cellpadding="2">';
				foreach ($newLang as $key => $value)
					echo '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.$k.'_'.md5($key).'" value="'.preg_replace('/"/', '\\"', stripslashes($value)).'" style="width: 350px"></td></tr>';
				echo '
						</table>
					</div>
				</fieldset><br />';
			}
		echo '<br /><input type="submit" name="submitTranslations" value="'.$this->l('Update translations').'" class="button" /></form>';
	}
}

?>