<?php

class BlockSearch extends Module
{    
    function __construct()
    {
        $this->name = 'blocksearch';
        $this->tab = 'Blocks';
        $this->version = 1.0;

		$this->_translations = array(
			'FR' => array(
				'Block quick search' => 'Bloc recherche rapide',
				'Adds a quick search block on your shop left column' => 'Ajoute un bloc de recherche rapide sur la colonne gauche de votre boutique',  
				'No configuration needed' => 'Ne requi&egrave;re pas de configuration',
				'Search' => 'Rechercher',
				'Enter a product name' => 'Entrez un nom de produit'
			)
		);

        parent::__construct();
        
        /* The parent construct is required for translations */
        $this->displayName = $this->l('Block quick search');
        $this->description = $this->l('Adds a quick search block on your shop left column');
    }

    function install()
    {
        parent::install();
        $this->registerHook('leftColumn');
    }
    
    function hookLeftColumn($params)
    {     	
     	return '
     	<!-- Block search module -->
		<div class="block_title">
			<img src="'.$this->_path.'logo.gif" alt="'.$this->l('Search').'" title="'.$this->l('Search').'" /> '.$this->l('Search').'
		</div>
		<div class="block search_block">
			'.$this->l('Enter a product name').'
			<form method="get" action="'.__PS_BASE_URI__.'search.php" id="searchbox">
			<div class="search_input">
				<input type="text" name="search_query" value="'.Tools::getValue('search_query').'" />
				<input type="image" src="'.$this->_path.'search_input.gif" />
			</div>
			</form>
		</div>
		<div class="block_footer"></div>
		<!-- /Block search module -->';
	}
}

?>